// Copyright (C) 2004-2025 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License along
// with this library; see the file COPYING3.  If not see
// <http://www.gnu.org/licenses/>.

// C++98 27.6.1.3 unformatted input functions

// { dg-require-fileio "" }
// { dg-additional-files "istream_unformatted-1.tst" }
// { dg-additional-files "istream_unformatted-1.txt" }
// Reading the .txt file should not alter it:
// { dg-final { file-io-diff "istream_unformatted-1" } }

#include <istream>
#include <sstream>
#include <fstream>
#include <testsuite_hooks.h>

//libstdc++/92: Bug in istream::get(basic_streambuf*)
// bug reported by bgarcia@laurelnetworks.com
// http://gcc.gnu.org/ml/libstdc++-prs/2000-q3/msg00041.html
void
test07()
{
  const char* tfn = "istream_unformatted-1.txt";
  std::wifstream infile;
  infile.open(tfn);
  VERIFY( !(!infile) );
  while (infile)
    {
      std::wstring line;
      std::wostringstream line_ss;
      while (infile.peek() == L'\n')
	infile.get();
      infile.get(*(line_ss.rdbuf()));
      line = line_ss.str();
      VERIFY( line == L"1234567890" || line == L"" );
    }
}

int 
main()
{
  test07();
  return 0;
}
